## PREREQUISITES

Firstly build locally the site which generates the public folder, then create the surge account as first time, after generate an access token for surge and set the CI/CD variables for the pipeline:
   
1. Clone the repository / Create a repo in your gitlab space
    ```bash
    $ git clone https://gitlab.com/enriqueperez/webapps/gatsby-to-surge.git
    $ cd gatsby-to-surge
    ```
    You can create a fork of this project and uploaded it to your gitlab space:
    `https://gitlab.com/{your_gitlab_space}/{path}/{your_project_repo}.git`

    Notice you must have two branches in the repository: _`develop`_, _`main`_

2. Install the gatsby client
    ```bash
    $ npm install
    $ npm install -g gatsby-cli
    ```
3. Build gatsby site inside the repo folder
    ```bash
    $ gatsby build
    ```
    This builds the site and generate the `public` folder with the content of the site.

4. Install surge client
    ```bash
    npm install --global surge
    ```
5. Init surge account
    ```bash
    surge
    ```
    In the command prompt, replace and introduce the following values:
    * email: `{replace_me}`
    * password: `{replace_me}`
    * project path: `./public` 
    * domain name: `{replace_me}`

6. Create the surge account access token
    ```bash
    surge token
    ```
7. Set the CI/CD variables
    Set the following variables in the ci/cd variables section of the project. For instance: `https://gitlab.com/{your_gitlab_space}/{path}/{your_project_repo}-/settings/ci_cd`

    With the values we indicated in step 5 create the masked variables:

    |   |   |
    |---|---|
    | SURGE_DOMAIN | _domain name_  |
    | SURGE_LOGIN  |  _email_ |
    | SURGE_TOKEN  |  _token_ |


    ![ci/cd variables](./cicd.png)

8. Test the pipeline

    The pipeline will be automatically triggered for each change depending on branch:
    - `develop`: Will trigger the build and test within the pipeline
    - `main`: will trigger the build, test, deploy to surge and post-deploy test.


    **Stop site**: There is manual job to teardown the surge site in pipeline


### GITFLOW
1. Update changes in develop branch locally
1. Test local changes
3. Push changes to develop branch 
    > _Pipeline triggers 'Tests'_
4. Create MR from develop to main
5. Merge the changes from develop to main (only if test pipeline success)
    > _Pipeline Deploy site into surge_

    > _Pipeline triggers 'Post-deploy Test'_

<h1></h1>


<!-- AUTO-GENERATED-CONTENT:START (STARTER) -->
<p align="center">
  <a href="https://www.gatsbyjs.com">
    <img alt="Gatsby" src="https://www.gatsbyjs.com/Gatsby-Monogram.svg" width="60" />
  </a>
</p>
<h1 align="center">
  Gatsby's default starter
</h1>

Kick off your project with this default boilerplate. This starter ships with the main Gatsby configuration files you might need to get up and running blazing fast with the blazing fast app generator for React.

_Have another more specific idea? You may want to check out our vibrant collection of [official and community-created starters](https://www.gatsbyjs.com/docs/gatsby-starters/)._

## 🚀 Quick start

1.  **Create a Gatsby site.**

    Use the Gatsby CLI to create a new site, specifying the default starter.

    ```shell
    # create a new Gatsby site using the default starter
    gatsby new my-default-starter https://github.com/gatsbyjs/gatsby-starter-default
    ```

1.  **Start developing.**

    Navigate into your new site’s directory and start it up.

    ```shell
    cd my-default-starter/
    gatsby develop
    ```

1.  **Open the source code and start editing!**

    Your site is now running at `http://localhost:8000`!

    _Note: You'll also see a second link: _`http://localhost:8000/___graphql`_. This is a tool you can use to experiment with querying your data. Learn more about using this tool in the [Gatsby tutorial](https://www.gatsbyjs.com/tutorial/part-five/#introducing-graphiql)._

    Open the `my-default-starter` directory in your code editor of choice and edit `src/pages/index.js`. Save your changes and the browser will update in real time!

## 🚀 Quick start (Gatsby Cloud)

Deploy this starter with one click on [Gatsby Cloud](https://www.gatsbyjs.com/cloud/):

[<img src="https://www.gatsbyjs.com/deploynow.svg" alt="Deploy to Gatsby Cloud">](https://www.gatsbyjs.com/dashboard/deploynow?url=https://github.com/gatsbyjs/gatsby-starter-default)

## 🧐 What's inside?

A quick look at the top-level files and directories you'll see in a Gatsby project.

    .
    ├── node_modules
    ├── src
    ├── .gitignore
    ├── .prettierrc
    ├── gatsby-browser.js
    ├── gatsby-config.js
    ├── gatsby-node.js
    ├── gatsby-ssr.js
    ├── LICENSE
    ├── package-lock.json
    ├── package.json
    └── README.md

1.  **`/node_modules`**: This directory contains all of the modules of code that your project depends on (npm packages) are automatically installed.

2.  **`/src`**: This directory will contain all of the code related to what you will see on the front-end of your site (what you see in the browser) such as your site header or a page template. `src` is a convention for “source code”.

3.  **`.gitignore`**: This file tells git which files it should not track / not maintain a version history for.

4.  **`.prettierrc`**: This is a configuration file for [Prettier](https://prettier.io/). Prettier is a tool to help keep the formatting of your code consistent.

5.  **`gatsby-browser.js`**: This file is where Gatsby expects to find any usage of the [Gatsby browser APIs](https://www.gatsbyjs.com/docs/browser-apis/) (if any). These allow customization/extension of default Gatsby settings affecting the browser.

6.  **`gatsby-config.js`**: This is the main configuration file for a Gatsby site. This is where you can specify information about your site (metadata) like the site title and description, which Gatsby plugins you’d like to include, etc. (Check out the [config docs](https://www.gatsbyjs.com/docs/gatsby-config/) for more detail).

7.  **`gatsby-node.js`**: This file is where Gatsby expects to find any usage of the [Gatsby Node APIs](https://www.gatsbyjs.com/docs/node-apis/) (if any). These allow customization/extension of default Gatsby settings affecting pieces of the site build process.

8.  **`gatsby-ssr.js`**: This file is where Gatsby expects to find any usage of the [Gatsby server-side rendering APIs](https://www.gatsbyjs.com/docs/ssr-apis/) (if any). These allow customization of default Gatsby settings affecting server-side rendering.

9.  **`LICENSE`**: This Gatsby starter is licensed under the 0BSD license. This means that you can see this file as a placeholder and replace it with your own license.

10. **`package-lock.json`** (See `package.json` below, first). This is an automatically generated file based on the exact versions of your npm dependencies that were installed for your project. **(You won’t change this file directly).**

11. **`package.json`**: A manifest file for Node.js projects, which includes things like metadata (the project’s name, author, etc). This manifest is how npm knows which packages to install for your project.

12. **`README.md`**: A text file containing useful reference information about your project.

## 🎓 Learning Gatsby

Looking for more guidance? Full documentation for Gatsby lives [on the website](https://www.gatsbyjs.com/). Here are some places to start:

- **For most developers, we recommend starting with our [in-depth tutorial for creating a site with Gatsby](https://www.gatsbyjs.com/tutorial/).** It starts with zero assumptions about your level of ability and walks through every step of the process.

- **To dive straight into code samples, head [to our documentation](https://www.gatsbyjs.com/docs/).** In particular, check out the _Guides_, _API Reference_, and _Advanced Tutorials_ sections in the sidebar.

## 💫 Deploy

[Build, Deploy, and Host On The Only Cloud Built For Gatsby](https://www.gatsbyjs.com/cloud/)

Gatsby Cloud is an end-to-end cloud platform specifically built for the Gatsby framework that combines a modern developer experience with an optimized, global edge network.

<!-- AUTO-GENERATED-CONTENT:END -->
